diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/ns3 ns-3.41/ns3
--- ns-3.40/ns3	2023-09-27 13:30:37.610839000 -0700
+++ ns-3.41/ns3	2024-02-09 14:44:07.845789700 -0800
@@ -362,18 +531,36 @@
                 if len(subcommand) > 1:
                     print(subcommand)
 
-        print(parser.format_help().replace(parser.description, "").replace(parser.format_usage(), ""))
+        print(
+            parser.format_help().replace(parser.description, "").replace(parser.format_usage(), "")
+        )
         exit(0)
 
     attributes_to_merge = ["jobs"]
-    filtered_attributes = list(filter(lambda x: x if ("disable" not in x and "enable" not in x) else 0, args.__dir__()))
+    filtered_attributes = list(
+        filter(lambda x: x if ("disable" not in x and "enable" not in x) else 0, args.__dir__())
+    )
     for attribute in attributes_to_merge:
         merging_attributes = list(
-            map(lambda x: int(args.__getattribute__(x)) if attribute in x else max_cpu_threads, filtered_attributes))
+            map(
+                lambda x: int(args.__getattribute__(x)) if attribute in x else max_cpu_threads,
+                filtered_attributes,
+            )
+        )
         setattr(args, attribute, min(merging_attributes))
 
     # If some positional options are not in args, set them to false.
-    for option in ["clean", "configure", "docs", "install", "run", "shell", "uninstall", "show", "distclean"]:
+    for option in [
+        "clean",
+        "configure",
+        "docs",
+        "install",
+        "run",
+        "shell",
+        "uninstall",
+        "show",
+        "distclean",
+    ]:
         if option not in args:
             setattr(args, option, False)
 
@@ -385,9 +572,11 @@
 
     # Emit error in case of unknown arguments
     if unknown_args:
-        msg = ("Unknown options were given: {options}.\n"
-               "To see the allowed options add the `--help` option.\n"
-               "To forward configuration or runtime options, put them after '--'.\n")
+        msg = (
+            "Unknown options were given: {options}.\n"
+            "To see the allowed options add the `--help` option.\n"
+            "To forward configuration or runtime options, put them after '--'.\n"
+        )
         if args.run:
             msg += "Try: ./ns3 run {target} -- {options}\n"
         if args.configure:
@@ -402,14 +591,15 @@
     ns3_modules_tests = []
     ns3_modules = None
 
-    build_info = {"NS3_ENABLED_MODULES": [],
-                  "BUILD_PROFILE": None,
-                  "VERSION": None,
-                  "ENABLE_EXAMPLES": False,
-                  "ENABLE_SUDO": False,
-                  "ENABLE_TESTS": False,
-                  "BUILD_VERSION_STRING": None
-                  }
+    build_info = {
+        "NS3_ENABLED_MODULES": [],
+        "BUILD_PROFILE": None,
+        "VERSION": None,
+        "ENABLE_EXAMPLES": False,
+        "ENABLE_SUDO": False,
+        "ENABLE_TESTS": False,
+        "BUILD_VERSION_STRING": None,
+    }
     if output_directory and os.path.exists(lock_file):
         exec(open(lock_file).read(), globals(), build_info)
         ns3_modules = build_info["NS3_ENABLED_MODULES"]
@@ -430,15 +620,18 @@
 def remove_dir(dir_to_remove, dry_run, directory_qualifier=""):
     dir_to_remove = os.path.abspath(dir_to_remove)
     if os.path.exists(dir_to_remove):
-        if (".." in os.path.relpath(dir_to_remove, ns3_path)
-            or os.path.abspath(dir_to_remove) == os.path.abspath(ns3_path)):
+        if ".." in os.path.relpath(dir_to_remove, ns3_path) or os.path.abspath(
+            dir_to_remove
+        ) == os.path.abspath(ns3_path):
             # In case the directory to remove isn't within
             # the current ns-3 directory, print an error
             # message for the dry-run case
             # Or throw an exception in a normal run
-            error_message = (f"The {directory_qualifier} directory '{dir_to_remove}' "
-                             "is not within the current ns-3 directory. "
-                             "Deleting it can cause data loss.")
+            error_message = (
+                f"The {directory_qualifier} directory '{dir_to_remove}' "
+                "is not within the current ns-3 directory. "
+                "Deleting it can cause data loss."
+            )
             if dry_run:
                 print_and_buffer(error_message)
                 return
@@ -466,28 +659,29 @@
         dirname = os.path.dirname(cmake_cache_file)
         remove_dir(dirname, dry_run, "CMake cache")
 
-    dirs_to_remove = [os.path.join(ns3_path, "testpy-output"),
-                      os.path.join(ns3_path, "__pycache__")
-                      ]
-    for dir_to_remove in dirs_to_remove:
+    dirs_to_remove = ["testpy-output", "__pycache__", "build", "cmake-cache"]
+    for dir_to_remove in map(append_to_ns3_path, dirs_to_remove):
         remove_dir(dir_to_remove, dry_run)
 
     remove_file(lock_file, dry_run)
 
 
 def clean_docs_and_tests_artifacts(dry_run=False):
-    docs_dir = os.path.join(ns3_path, 'doc')
+    docs_dir = append_to_ns3_path("doc")
 
-    file_artifacts = ["doxygen.log",
-                      "doxygen.warnings.log",
-                      "introspected-command-line.h",
-                      "introspected-doxygen.h",
-                      "ns3-object.txt"]
+    file_artifacts = [
+        "doxygen.log",
+        "doxygen.warnings.log",
+        "introspected-command-line.h",
+        "introspected-doxygen.h",
+        "ns3-object.txt",
+    ]
     docs_files = [os.path.join(docs_dir, filename) for filename in file_artifacts]
 
-    docs_and_tests_dirs = [os.path.join(docs_dir, "html"),
-                           os.path.join(docs_dir, "html-warn"),
-                           ]
+    docs_and_tests_dirs = [
+        os.path.join(docs_dir, "html"),
+        os.path.join(docs_dir, "html-warn"),
+    ]
     docs_and_tests_dirs.extend(glob.glob(f"{docs_dir}/**/build", recursive=True))
     docs_and_tests_dirs.extend(glob.glob(f"{docs_dir}/**/source-temp", recursive=True))
 
@@ -499,16 +693,13 @@
 
 
 def clean_pip_packaging_artifacts(dry_run=False):
-    pip_dirs = [os.path.join(ns3_path, "dist"),
-                os.path.join(ns3_path, "nsnam.egg-info"),
-                os.path.join(ns3_path, "wheelhouse")
-                ]
-    for directory in pip_dirs:
+    pip_dirs = ["dist", "nsnam.egg-info", "wheelhouse"]
+    for directory in map(append_to_ns3_path, pip_dirs):
         remove_dir(directory, dry_run)
 
 
 def clean_vcpkg_artifacts(dry_run=False):
-    remove_dir(os.path.join(ns3_path, "vcpkg"), dry_run)
+    remove_dir(append_to_ns3_path("vcpkg"), dry_run)
 
 
 def search_cmake_cache(build_profile):
@@ -552,10 +743,7 @@
 
     if not current_cmake_generator:
         # Search for available generators
-        cmake_generator_map = {"ninja": "Ninja",
-                               "make": "Unix Makefiles",
-                               "xcodebuild": "Xcode"
-                               }
+        cmake_generator_map = {"ninja": "Ninja", "make": "Unix Makefiles", "xcodebuild": "Xcode"}
         available_generators = []
         for generator in cmake_generator_map.keys():
             if shutil.which(generator):
@@ -595,9 +783,11 @@
     return True
 
 
-def configure_cmake(cmake, args, current_cmake_cache_folder, current_cmake_generator, output, dry_run=False):
+def configure_cmake(
+    cmake, args, current_cmake_cache_folder, current_cmake_generator, output, dry_run=False
+):
     # Aggregate all flags to configure CMake
-    cmake_args = [cmake]
+    cmake_args = [cmake, "-S", ns3_path]
 
     if not project_configured(current_cmake_cache_folder):
         # Create a new cmake_cache folder if one does not exist
@@ -619,10 +809,13 @@
         # CMake with the respective installation
         if args.enable_python_bindings is True:
             import sysconfig
+
             cmake_args.append(f"-DPython3_LIBRARY_DIRS={sysconfig.get_config_var('LIBDIR')}")
             cmake_args.append(f"-DPython3_INCLUDE_DIRS={sysconfig.get_config_var('INCLUDEPY')}")
             cmake_args.append(f"-DPython3_EXECUTABLE={sys.executable}")
 
+    cmake_args.extend(["-B", current_cmake_cache_folder])
+
     # C++ standard
     if args.cxx_standard is not None:
         cmake_args.append("-DCMAKE_CXX_STANDARD=%s" % args.cxx_standard)
@@ -630,54 +823,66 @@
     # Build type
     if args.build_profile is not None:
         args.build_profile = args.build_profile.lower()
-        if args.build_profile not in ["debug", "default", "release", "optimized", "minsizerel", "relwithdebinfo"]:
+        if args.build_profile not in [
+            "debug",
+            "default",
+            "release",
+            "optimized",
+            "minsizerel",
+            "relwithdebinfo",
+        ]:
             raise Exception("Unknown build type")
         else:
             if args.build_profile == "debug":
                 cmake_args.extend(
-                    "-DCMAKE_BUILD_TYPE=debug -DNS3_ASSERT=ON -DNS3_LOG=ON -DNS3_WARNINGS_AS_ERRORS=ON".split())
+                    "-DCMAKE_BUILD_TYPE=debug -DNS3_ASSERT=ON -DNS3_LOG=ON -DNS3_WARNINGS_AS_ERRORS=ON".split()
+                )
             elif args.build_profile in ["default", "relwithdebinfo"]:
                 cmake_args.extend(
-                    "-DCMAKE_BUILD_TYPE=default -DNS3_ASSERT=ON -DNS3_LOG=ON -DNS3_WARNINGS_AS_ERRORS=OFF".split())
+                    "-DCMAKE_BUILD_TYPE=default -DNS3_ASSERT=ON -DNS3_LOG=ON -DNS3_WARNINGS_AS_ERRORS=OFF".split()
+                )
             elif args.build_profile in ["release", "optimized"]:
                 cmake_args.extend(
-                    "-DCMAKE_BUILD_TYPE=release -DNS3_ASSERT=OFF -DNS3_LOG=OFF -DNS3_WARNINGS_AS_ERRORS=OFF".split())
+                    "-DCMAKE_BUILD_TYPE=release -DNS3_ASSERT=OFF -DNS3_LOG=OFF -DNS3_WARNINGS_AS_ERRORS=OFF".split()
+                )
             else:
                 cmake_args.extend(
                     "-DCMAKE_BUILD_TYPE=minsizerel -DNS3_ASSERT=OFF -DNS3_LOG=OFF -DNS3_WARNINGS_AS_ERRORS=OFF".split()
                 )
-            cmake_args.append("-DNS3_NATIVE_OPTIMIZATIONS=%s" % on_off((args.build_profile == "optimized")))
-
-    options = (("ASSERT", "asserts"),
-               ("CLANG_TIDY", "clang_tidy"),
-               ("COVERAGE", "gcov"),
-               ("DES_METRICS", "des_metrics"),
-               ("DPDK", "dpdk"),
-               ("EIGEN", "eigen"),
-               ("ENABLE_BUILD_VERSION", "build_version"),
-               ("ENABLE_SUDO", "sudo"),
-               ("EXAMPLES", "examples"),
-               ("GSL", "gsl"),
-               ("GTK3", "gtk"),
-               ("LOG", "logs"),
-               ("MONOLIB", "monolib"),
-               ("MPI", "mpi"),
-               ("NINJA_TRACING", "ninja_tracing"),
-               ("PRECOMPILE_HEADERS", "precompiled_headers"),
-               ("PYTHON_BINDINGS", "python_bindings"),
-               ("SANITIZE", "sanitizers"),
-               ("STATIC", "static"),
-               ("TESTS", "tests"),
-               ("VERBOSE", "verbose"),
-               ("WARNINGS", "warnings"),
-               ("WARNINGS_AS_ERRORS", "werror"),
-               )
-    for (cmake_flag, option_name) in options:
+            cmake_args.append(
+                "-DNS3_NATIVE_OPTIMIZATIONS=%s" % on_off((args.build_profile == "optimized"))
+            )
+
+    options = (
+        ("ASSERT", "asserts"),
+        ("CLANG_TIDY", "clang_tidy"),
+        ("COVERAGE", "gcov"),
+        ("DES_METRICS", "des_metrics"),
+        ("DPDK", "dpdk"),
+        ("EIGEN", "eigen"),
+        ("ENABLE_BUILD_VERSION", "build_version"),
+        ("ENABLE_SUDO", "sudo"),
+        ("EXAMPLES", "examples"),
+        ("GSL", "gsl"),
+        ("GTK3", "gtk"),
+        ("LOG", "logs"),
+        ("MONOLIB", "monolib"),
+        ("MPI", "mpi"),
+        ("NINJA_TRACING", "ninja_tracing"),
+        ("PRECOMPILE_HEADERS", "precompiled_headers"),
+        ("PYTHON_BINDINGS", "python_bindings"),
+        ("SANITIZE", "sanitizers"),
+        ("STATIC", "static"),
+        ("TESTS", "tests"),
+        ("VERBOSE", "verbose"),
+        ("WARNINGS", "warnings"),
+        ("WARNINGS_AS_ERRORS", "werror"),
+    )
+    for cmake_flag, option_name in options:
         arg = on_off_condition(args, cmake_flag, option_name)
         if arg:
             is_on = "=ON" in arg
-            reverse = arg.replace("=ON" if is_on else "=OFF",
-                                  "=OFF" if is_on else "=ON")
+            reverse = arg.replace("=ON" if is_on else "=OFF", "=OFF" if is_on else "=ON")
             if reverse in cmake_args:
                 cmake_args.remove(reverse)
             cmake_args.append(arg)
@@ -709,35 +914,35 @@
         cmake_args.append("-DNS3_DISABLED_MODULES=%s" % args.disable_modules)
 
     if args.filter_module_examples_and_tests is not None:
-        cmake_args.append("-DNS3_FILTER_MODULE_EXAMPLES_AND_TESTS=%s" % args.filter_module_examples_and_tests)
+        cmake_args.append(
+            "-DNS3_FILTER_MODULE_EXAMPLES_AND_TESTS=%s" % args.filter_module_examples_and_tests
+        )
 
     # Try to set specified generator (will probably fail if there is an old cache)
     if args.G:
         cmake_args.extend(["-G", args.G])
 
     if args.trace_cmake_perf:
-        cmake_performance_trace = os.path.join(os.path.relpath(ns3_path, current_cmake_cache_folder),
-                                               "cmake_performance_trace.log")
-        cmake_args.extend(["--profiling-format=google-trace",
-                           "--profiling-output=" + cmake_performance_trace])
+        cmake_performance_trace = os.path.join(
+            os.path.relpath(ns3_path, ns3_path), "cmake_performance_trace.log"
+        )
+        cmake_args.extend(
+            ["--profiling-format=google-trace", "--profiling-output=" + cmake_performance_trace]
+        )
+
+    # Enable warnings for uninitialized variable usage
+    cmake_args.append("--warn-uninitialized")
 
     # Append CMake flags passed using the -- separator
     cmake_args.extend(args.program_args)
 
-    # Configure cmake
-    cmake_args.append("..")  # for now, assuming the cmake_cache directory is inside the ns-3-dev folder
-
     # Echo out the configure command
-    print_and_buffer("cd %s; %s ; cd %s" % (os.path.relpath(current_cmake_cache_folder, ns3_path),
-                                            " ".join(cmake_args),
-                                            os.path.relpath(ns3_path, current_cmake_cache_folder)
-                                            )
-                     )
+    print_and_buffer(" ".join(cmake_args))
 
     # Run cmake
     if not dry_run:
         proc_env = os.environ.copy()
-        ret = subprocess.run(cmake_args, cwd=current_cmake_cache_folder, stdout=output, env=proc_env)
+        ret = subprocess.run(cmake_args, stdout=output, env=proc_env)
         if ret.returncode != 0:
             exit(ret.returncode)
 
@@ -746,7 +951,7 @@
 
 def update_scratches_list(current_cmake_cache_folder):
     # Store list of scratches to trigger a reconfiguration step if needed
-    current_scratch_sources = glob.glob(os.path.join(ns3_path, "scratch", "**", "*.cc"), recursive=True)
+    current_scratch_sources = glob.glob(append_to_ns3_path("scratch", "**", "*.cc"), recursive=True)
     with open(os.path.join(current_cmake_cache_folder, "ns3scratches"), "w") as f:
         f.write("\n".join(current_scratch_sources))
 
@@ -774,11 +979,13 @@
         temp_path = program.replace(out_dir, "")
         # Sometimes Windows uses \\, sometimes /
         # quite the mess
-        temp_path = temp_path.split(os.sep if os.sep in temp_path else '/')
+        temp_path = temp_path.split(os.sep if os.sep in temp_path else "/")
         temp_path.pop(0)  # remove first path separator
 
         # Remove version prefix and build type suffix from shortcuts (or keep them too?)
-        temp_path[-1] = temp_path[-1].replace("-" + build_profile, "").replace("ns" + ns3_version + "-", "")
+        temp_path[-1] = (
+            temp_path[-1].replace("-" + build_profile, "").replace("ns" + ns3_version + "-", "")
+        )
 
         # Deal with scratch subdirs
         if "scratch" in temp_path and len(temp_path) > 3:
@@ -788,7 +995,7 @@
         # Check if there is a .cc file for that specific program
         source_file_path = os.sep.join(temp_path) + ".cc"
         source_shortcut = False
-        if os.path.exists(os.path.join(ns3_path, source_file_path)):
+        if os.path.exists(append_to_ns3_path(source_file_path)):
             source_shortcut = True
 
         program = program.strip()
@@ -829,11 +1036,11 @@
 
     # Filter collisions
     collisions = list(filter(lambda x: x if len(x[1]) > 1 else None, longest_shortcut_map.items()))
-    for (colliding_shortcut, longest_shortcuts) in collisions:
+    for colliding_shortcut, longest_shortcuts in collisions:
         ns3_program_map[colliding_shortcut] = longest_shortcuts
 
     if programs_dict["ns3_runnable_scripts"]:
-        scratch_scripts = glob.glob(os.path.join(ns3_path, "scratch", "*.py"), recursive=True)
+        scratch_scripts = glob.glob(append_to_ns3_path("scratch", "*.py"), recursive=True)
         programs_dict["ns3_runnable_scripts"].extend(scratch_scripts)
 
     for program in programs_dict["ns3_runnable_scripts"]:
@@ -854,37 +1061,41 @@
 
 def cmake_check_version():
     # Check CMake version
+    minimum_cmake_version = "3.13.0"
     cmake3 = shutil.which("cmake3")
     cmake = cmake3 if cmake3 else shutil.which("cmake")
     if not cmake:
-        print("Error:  CMake not found; please install version 3.10 or greater, or modify", path_variable)
+        print(
+            f"Error:  CMake not found; please install version {minimum_cmake_version} or greater, or modify {path_variable}"
+        )
         exit(1)
     cmake = cmake.replace(".EXE", "").replace(".exe", "")  # Trim cmake executable extension
     cmake_output = subprocess.check_output([cmake, "--version"]).decode("utf-8")
     version = re.findall("version (.*)", cmake_output)[0]
-    if parse_version(version) < parse_version("3.10.0"):
-        print("Error:  CMake found at %s but version %s is older than 3.10" % (cmake, version))
+    if parse_version(version) < parse_version(minimum_cmake_version):
+        print(
+            f"Error:  CMake found at {cmake} but version {version} is older than {minimum_cmake_version}"
+        )
         exit(1)
     return cmake, version
 
 
-def cmake_build(current_cmake_cache_folder, output, jobs, target=None, dry_run=False, build_verbose=False):
+def cmake_build(
+    current_cmake_cache_folder, output, jobs, target=None, dry_run=False, build_verbose=False
+):
     cmake, version = cmake_check_version()
 
-    # Older CMake versions don't accept the number of jobs directly
-    jobs_part = ("-j %d" % jobs) if parse_version(version) >= parse_version("3.12.0") else ""
-    target_part = (" --target %s" % target) if target else ""
-    cmake_build_command = "%s --build . %s%s" % (cmake, jobs_part, target_part)
-
-    print_and_buffer("cd %s; %s ; cd %s" % (os.path.relpath(current_cmake_cache_folder, ns3_path),
-                                            cmake_build_command,
-                                            os.path.relpath(ns3_path, current_cmake_cache_folder)
-                                            )
-                     )
+    cmake_args = [cmake, "--build", current_cmake_cache_folder]
+    if jobs:
+        cmake_args.extend(["-j", str(jobs)])
+
+    if target:
+        cmake_args.extend(["--target", target])
+
+    print_and_buffer(" ".join(cmake_args))
     if not dry_run:
         # Assume quiet is not enabled, and print things normally
-        kwargs = {"stdout": None,
-                  "stderr": None}
+        kwargs = {"stdout": None, "stderr": None}
 
         proc_env = os.environ.copy()
         if build_verbose:
@@ -898,11 +1109,11 @@
             kwargs["stdout"] = subprocess.PIPE
             kwargs["stderr"] = subprocess.PIPE
 
-        ret = subprocess.run(cmake_build_command.split(),
-                             cwd=current_cmake_cache_folder,
-                             env=proc_env,
-                             **kwargs,
-                             )
+        ret = subprocess.run(
+            cmake_args,
+            env=proc_env,
+            **kwargs,
+        )
 
         # Print errors in case compilation fails and output != None (quiet)
         if ret.returncode != 0 and output is not None:
@@ -916,18 +1127,24 @@
 
 def extract_cmakecache_settings(current_cmake_cache_folder):
     try:
-        with open(current_cmake_cache_folder + os.sep + "CMakeCache.txt", "r", encoding="utf-8") as f:
+        with open(
+            current_cmake_cache_folder + os.sep + "CMakeCache.txt", "r", encoding="utf-8"
+        ) as f:
             contents = f.read()
     except FileNotFoundError as e:
         raise e
     current_settings = re.findall("(NS3_.*):.*=(.*)", contents)  # extract NS3 specific settings
-    current_settings.extend(re.findall("(CMAKE_BUILD_TYPE):.*=(.*)", contents))  # extract build type
+    current_settings.extend(
+        re.findall("(CMAKE_BUILD_TYPE):.*=(.*)", contents)
+    )  # extract build type
     current_settings.extend(re.findall("(CMAKE_GENERATOR):.*=(.*)", contents))  # extract generator
     current_settings.extend(re.findall("(CMAKE_CXX_COMPILER):.*=(.*)", contents))  # C++ compiler
     current_settings.extend(re.findall("(CMAKE_CXX_FLAGS):.*=(.*)", contents))  # C++ flags
     current_settings.extend(re.findall("(CMAKE_C_COMPILER):.*=(.*)", contents))  # C compiler
     current_settings.extend(re.findall("(CMAKE_C_FLAGS):.*=(.*)", contents))  # C flags
-    current_settings.extend(re.findall("(CMAKE_INSTALL_PREFIX):.*=(.*)", contents))  # installation directory
+    current_settings.extend(
+        re.findall("(CMAKE_INSTALL_PREFIX):.*=(.*)", contents)
+    )  # installation directory
 
     # Transform list into dictionary
     settings_dictionary = dict(current_settings)
@@ -939,6 +1156,7 @@
 
 def reconfigure_cmake_to_force_refresh(cmake, current_cmake_cache_folder, output, dry_run=False):
     import json
+
     settings_bak_file = "settings.json"
 
     # Extract settings or recover from the backup
@@ -967,11 +1185,14 @@
     cmake_args.append("..")
 
     # Echo out the configure command
-    print_and_buffer("cd %s; %s ; cd %s" % (os.path.relpath(ns3_path, current_cmake_cache_folder),
-                                            " ".join(cmake_args),
-                                            os.path.relpath(current_cmake_cache_folder, ns3_path)
-                                            )
-                     )
+    print_and_buffer(
+        "cd %s; %s ; cd %s"
+        % (
+            os.path.relpath(ns3_path, current_cmake_cache_folder),
+            " ".join(cmake_args),
+            os.path.relpath(current_cmake_cache_folder, ns3_path),
+        )
+    )
 
     # Call cmake
     if not dry_run:
@@ -981,8 +1202,10 @@
         if ret.returncode == 0:
             os.remove(settings_bak_file)
         else:
-            raise Exception("Reconfiguring CMake to force refresh failed. "
-                            "A backup of the settings was saved in %s" % settings_bak_file)
+            raise Exception(
+                "Reconfiguring CMake to force refresh failed. "
+                "A backup of the settings was saved in %s" % settings_bak_file
+            )
 
         update_scratches_list(current_cmake_cache_folder)
 
@@ -995,7 +1218,9 @@
     program_name = ""
 
     try:
-        program_name = "".join(*re.findall("(.*)ns%s-(.*)%s" % (ns3_version, build_profile_suffix), program_path))
+        program_name = "".join(
+            *re.findall("(.*)ns%s-(.*)%s" % (ns3_version, build_profile_suffix), program_path)
+        )
     except TypeError:
         print("Target to build does not exist: %s" % program_path)
         exit(1)
@@ -1009,8 +1234,9 @@
         return program_name.split("/")[-1]
 
 
-def configuration_step(current_cmake_cache_folder, current_cmake_generator, args,
-                       output, dry_run=False):
+def configuration_step(
+    current_cmake_cache_folder, current_cmake_generator, args, output, dry_run=False
+):
     # Search for the CMake binary
     cmake, _ = cmake_check_version()
 
@@ -1021,55 +1247,56 @@
         exit(0)
 
     # Call cmake to configure/reconfigure/refresh the project
-    configure_cmake(cmake,
-                    args,
-                    current_cmake_cache_folder,
-                    current_cmake_generator,
-                    output,
-                    dry_run
-                    )
+    configure_cmake(
+        cmake, args, current_cmake_cache_folder, current_cmake_generator, output, dry_run
+    )
 
     # If manually configuring, we end the script earlier
     exit(0)
 
 
-def build_step(args,
-               build_and_run,
-               target_to_run,
-               current_cmake_cache_folder,
-               ns3_modules,
-               ns3_version,
-               build_profile,
-               output):
+def build_step(
+    args,
+    build_and_run,
+    target_to_run,
+    current_cmake_cache_folder,
+    ns3_modules,
+    ns3_version,
+    build_profile,
+    output,
+):
     # There is one scenario where we build everything: ./ns3 build
     if "build" in args and len(args.build) == 0:
-        cmake_build(current_cmake_cache_folder,
-                    jobs=args.jobs,
-                    output=output,
-                    dry_run=args.dry_run,
-                    build_verbose=args.verbose
-                    )
+        cmake_build(
+            current_cmake_cache_folder,
+            jobs=args.jobs,
+            output=output,
+            dry_run=args.dry_run,
+            build_verbose=args.verbose,
+        )
 
     # If we are building specific targets, we build them one by one
     if "build" in args:
-        non_executable_targets = ["assemble-introspected-command-line",
-                                  "check-version",
-                                  "cmake-format",
-                                  "coverage_gcc",
-                                  "docs",
-                                  "doxygen",
-                                  "doxygen-no-build",
-                                  "installation",
-                                  "sphinx",
-                                  "manual",
-                                  "models",
-                                  "ninjaTrace",
-                                  "timeTraceReport",
-                                  "tutorial",
-                                  "contributing",
-                                  "install",
-                                  "uninstall",
-                                  ]
+        non_executable_targets = [
+            "assemble-introspected-command-line",
+            "check-version",
+            "cmake-format",
+            "cmake-format-check",
+            "coverage_gcc",
+            "docs",
+            "doxygen",
+            "doxygen-no-build",
+            "installation",
+            "sphinx",
+            "manual",
+            "models",
+            "ninjaTrace",
+            "timeTraceReport",
+            "tutorial",
+            "contributing",
+            "install",
+            "uninstall",
+        ]
         # Build targets in the list
         for target in args.build:
             if target in ns3_modules:
@@ -1090,22 +1317,25 @@
                     global run_verbose
                     run_verbose = False  # Do not print the equivalent cmake command
 
-            cmake_build(current_cmake_cache_folder,
-                        jobs=args.jobs,
-                        target=target,
-                        output=output,
-                        dry_run=args.dry_run,
-                        build_verbose=args.verbose)
+            cmake_build(
+                current_cmake_cache_folder,
+                jobs=args.jobs,
+                target=target,
+                output=output,
+                dry_run=args.dry_run,
+                build_verbose=args.verbose,
+            )
 
     # The remaining case is when we want to build something to run
     if build_and_run:
-        cmake_build(current_cmake_cache_folder,
-                    jobs=args.jobs,
-                    target=get_target_to_build(target_to_run, ns3_version, build_profile),
-                    output=output,
-                    dry_run=args.dry_run,
-                    build_verbose=args.verbose
-                    )
+        cmake_build(
+            current_cmake_cache_folder,
+            jobs=args.jobs,
+            target=get_target_to_build(target_to_run, ns3_version, build_profile),
+            output=output,
+            dry_run=args.dry_run,
+            build_verbose=args.verbose,
+        )
 
 
 def check_program_installed(program_name: str) -> str:
@@ -1118,6 +1348,7 @@
 
 def check_module_installed(module_name: str):
     import importlib
+
     try:
         importlib.import_module(module_name)
     except ImportError:
@@ -1128,14 +1359,15 @@
 def run_step(args, target_to_run, target_args):
     libdir = "%s/lib" % out_dir
 
-    custom_env = {"PATH": libdir,
-                  "PYTHONPATH": "%s/bindings/python" % out_dir,
-                  }
+    custom_env = {
+        "PATH": libdir,
+        "PYTHONPATH": "%s/bindings/python" % out_dir,
+    }
     if sys.platform != "win32":
         custom_env["LD_LIBRARY_PATH"] = libdir
 
     proc_env = os.environ.copy()
-    for (key, value) in custom_env.items():
+    for key, value in custom_env.items():
         if key in proc_env:
             proc_env[key] += path_sep + value
         else:
@@ -1158,7 +1390,14 @@
             # running with memray?
             if args.memray:
                 check_module_installed("memray")
-                target_args = ["-m", "memray", "run", "-o", "memray.output", "--native"] + target_args
+                target_args = [
+                    "-m",
+                    "memray",
+                    "run",
+                    "-o",
+                    "memray.output",
+                    "--native",
+                ] + target_args
 
         # running from ns-3-dev (ns3_path) or cwd
         if args.cwd:
@@ -1171,7 +1410,8 @@
         # running valgrind?
         if args.valgrind:
             debugging_software.extend(
-                [check_program_installed("valgrind"), "--leak-check=full", "--show-leak-kinds=all"])
+                [check_program_installed("valgrind"), "--leak-check=full", "--show-leak-kinds=all"]
+            )
 
         # running gdb?
         if args.gdb:
@@ -1186,11 +1426,16 @@
 
         # running with perf?
         if args.perf:
-            debugging_software.extend([
-                check_program_installed("perf"),
-                "record", "--call-graph", "dwarf", "-e",
-                "cache-misses,branch-misses,cpu-cycles,stalled-cycles-frontend,stalled-cycles-backend"
-            ])
+            debugging_software.extend(
+                [
+                    check_program_installed("perf"),
+                    "record",
+                    "--call-graph",
+                    "dwarf",
+                    "-e",
+                    "cache-misses,branch-misses,cpu-cycles,stalled-cycles-frontend,stalled-cycles-backend",
+                ]
+            )
 
         # running with the visualizer?
         if args.visualize:
